﻿<ResourceDictionary xmlns="http://schemas.microsoft.com/winfx/2006/xaml/presentation"
                    xmlns:x="http://schemas.microsoft.com/winfx/2006/xaml"
                    xmlns:vm="clr-namespace:AbreVinci.Embryo.Debugging.ViewModels;assembly=AbreVinci.Embryo.Debugging">

    <DataTemplate x:Key="DebuggerValueView" DataType="{x:Type vm:DebuggerValueViewModel}">
        <DataTemplate.Resources>
            <ControlTemplate x:Key="ExpandButtonTemplate" TargetType="ButtonBase">
                <Border Width="15" Height="15" BorderBrush="LightGray" BorderThickness="1" Background="Transparent">
                    <ContentPresenter HorizontalAlignment="Center" VerticalAlignment="Center" />
                </Border>
            </ControlTemplate>
            <DataTemplate DataType="{x:Type vm:SingleDebuggerValueViewModel}">
                <TextBlock TextWrapping="Wrap">
                    <Run Text="{Binding KeyText, Mode=OneWay}" />
                    <Run Text="{Binding Type, Mode=OneTime, StringFormat=[{0}], TargetNullValue=''}" Foreground="Gray" FontStyle="Italic" FontSize="10" />
                    <Run Text="{Binding Value, Mode=OneWay, TargetNullValue='null'}" />
                </TextBlock>
            </DataTemplate>
            <DataTemplate DataType="{x:Type vm:CompoundDebuggerValueViewModel}">
                <StackPanel>
                    <TextBlock TextWrapping="Wrap">
                        <ToggleButton Name="expandButton" Content="+" IsChecked="{Binding IsExpanded, Mode=TwoWay}" Template="{StaticResource ExpandButtonTemplate}" Margin="0 0 0 -2" />
                        <Run Text="{Binding KeyText, Mode=OneWay}" />
                        <Run Text="{Binding Type, Mode=OneTime, StringFormat=[{0}], TargetNullValue=''}" Foreground="Gray" FontStyle="Italic" FontSize="10" />
                    </TextBlock>
                    <ItemsControl Name="items" Visibility="Collapsed" Margin="20 0 0 0" ItemsSource="{Binding Values}" />
                </StackPanel>
                <DataTemplate.Triggers>
                    <DataTrigger Binding="{Binding IsExpanded}" Value="True">
                        <Setter TargetName="items" Property="Visibility" Value="Visible" />
                        <Setter TargetName="expandButton" Property="Content" Value="-" />
                    </DataTrigger>
                </DataTemplate.Triggers>
            </DataTemplate>
        </DataTemplate.Resources>
        <ContentControl Content="{Binding}" />
    </DataTemplate>
    
</ResourceDictionary>
